<'
# Copyright (c) 2011-2012 LAAS/CNRS
# All rights reserved.
#
# Redistribution and use  in source  and binary  forms,  with or without
# modification, are permitted provided that the following conditions are
# met:
#
#   1. Redistributions of  source  code must retain the  above copyright
#      notice and this list of conditions.
#   2. Redistributions in binary form must reproduce the above copyright
#      notice and  this list of  conditions in the  documentation and/or
#      other materials provided with the distribution.
#
#                                      Anthony Mallet on Thu Mar  2 2012
#

if {[llength $argv] != 1} { error "expected arguments: component" }
lassign $argv component

# compute handy shortcuts
set comp [$component name]
set COMP [string toupper [$component name]]

lang c
'>
#ifndef H_<"$COMP">_ACTIVITY
#define H_<"$COMP">_ACTIVITY

#include "typecopy.h"
#include "<"$comp">_parameters.h"

#define <"$COMP">_MAX_ACTIVITIES	32

enum genom_activity_status {
  ACT_VOID, ACT_WAIT, ACT_RUN, ACT_STOP, ACT_INTER, ACT_ETHER
};

struct genom_activity {
  int sid, rid, aid;
  enum genom_activity_status status;
  <"[[$component event] declarator state]">;
  int interrupted;
};


/* === Service activity ==================================================== */

<'foreach s [$component services] {'>

/* <"[--- [$s name] -----------------------------------------------------]"> */

/* activity data */
struct genom_<"$comp">_<"[$s name]">_activity {
  struct genom_activity h;
  struct genom_<"$comp">_<"[$s name]">_input in;
  struct genom_<"$comp">_<"[$s name]">_output out;
};

/* input/output initializer */
static __inline__ void
genom_tinit_<"$comp">_<"[$s name]">_activity(
  struct genom_<"$comp">_<"[$s name]">_activity *a)
{
<'  foreach p [$s parameters in inout] {'>
  genom_tinit_<"[mangle [$p type]]">(
    <"[[$p type] pass reference a->in.[$p name]]">);
<'  }'>
<'  foreach p [$s parameters inout out] {'>
  genom_tinit_<"[mangle [$p type]]">(
    <"[[$p type] pass reference a->out.[$p name]]">);
<'  }'>
}

/* input/output finalizer */
static __inline__ void
genom_tfini_<"$comp">_<"[$s name]">_activity(
  struct genom_<"$comp">_<"[$s name]">_activity *a)
{
<'  foreach p [$s parameters in inout] {'>
  genom_tfini_<"[mangle [$p type]]">(
    <"[[$p type] pass reference a->in.[$p name]]">);
<'  }'>
<'  foreach p [$s parameters inout out] {'>
  genom_tfini_<"[mangle [$p type]]">(
    <"[[$p type] pass reference a->out.[$p name]]">);
<'  }'>
}

<'}'>


/* === Activities ========================================================== */

struct genom_activities {
  int last;
  union {
    struct genom_activity any;
<'foreach s [$component services] {'>
    struct genom_<"$comp">_<"[$s name]">_activity s_<"[$s name]">;
<'}'>
  } i[<"$COMP">_MAX_ACTIVITIES];
};

int	genom_<"$comp">_activity_alloc(struct genom_<"$comp">_cntrlstr *cids);
void	genom_<"$comp">_activity_free(struct genom_<"$comp">_cntrlstr *cids,
                int id);
void	genom_<"$comp">_activity_report(struct genom_<"$comp">_cntrlstr *cids,
		struct genom_activity *a);
int	genom_<"$comp">_interrupt_reqd(struct genom_<"$comp">_cntrlstr *cids,
		struct genom_activity *a);

#endif /* H_<"$COMP">_ACTIVITY */
